#ifndef KLINK_H
#define KLINK_H
#include <iostream>
using namespace std;

// store data on the heap
template <class T>
class Node{
public:
	T data;     // store data
	Node *next; // pointer to next node
	Node(T x):data(x),next(0){};
};



template <class T>
class klink{
private:
	Node<T> *head;
public:
	klink():head(0){};
	Node<T> * getHead(){return head;}
	bool empty(){return !head;}

	// copy c-tor
	klink(klink<T> & kc){
		Node<T> *curr_kc = kc.getHead();
		head = 0;
		while(curr_kc){
		   this->add(curr_kc->data);
		   curr_kc = curr_kc->next;
		}
	}

	// erase a node
    void erase(T a){

		// case 1: remove from empty list
		if(empty()){
			cout<< "can not remove from empty list" << endl;
			return;
		}
		
		// case 2: data at head
		if(a == head->data){
			Node<T>*tmp = head;
			head = head->next;
			delete tmp;
			return;
		}

		Node<T> *prev = 0, *curr=head;
		while(curr){
			if(curr->data == a)break;
			prev = curr;
			curr = curr->next;
		}

		// case 3: data not found
		if(!curr){
			cout << " data " << a << " not found " << endl;
			return;
		}

		// case 4: data in middle or end
		prev->next = curr->next;
		delete curr;

	}

	// add a node to the list
	void add(T a){

		// always make a new node
		Node<T> *nn = new Node<T>(a);

		// case 1: empty list
		if(head==0){
			head = nn;
			return;
		}

		// case 2: insert new head
		if(a < head->data){
			nn->next = head;
			head = nn;
			return;
		}

		// search for insertion point
        Node<T> *curr = head, *prev = 0;
		while(curr){
			if(a < curr->data)break;
			prev = curr;
			curr = curr->next;
		}

		// case 3: insert in middle
		if(curr){
           prev->next = nn;
		   nn->next = curr;
		   return;
		}

		// case 4: insert at end
		prev->next = nn;

	}

	// destructor
	~klink(){
		Node<T>*curr = head;
		while(curr){
			Node<T>*tmp = curr;
			curr = curr->next;
			delete tmp;
		}
	}
};


template <class T>
ostream& operator<<(ostream &os, klink<T>& k){
	Node<T> *curr = k.getHead();
	if(!curr){
		os << "EMPTY LIST" << endl;
		return os;
	}
	while(curr){
		os << curr->data << endl;
		curr = curr->next;
	}
	return os;
}



#endif
